;EX3.ORC: GERNERATES GRANULAR TEXTURES WITH SINES.
;Use with "ex3.csg"
;Compiled by Mikel Kuehn, 3/01

sr      =      	44100
kr    	=     	4410
ksmps  	=     	10
nchnls	=	2

	instr  	1
iamp 	= 	p4	;amplitude
ifrq	= 	cpspch(p5)  	;freqency in oct.pch  
ifspd	=	p6	;speed of freq deviations
ifsd	=	p7	;random number seed for devs
iaspd	=	p8	;amplitude deviation speed
iasd	=	p9	;amplitude deviation seed
ienvf	=	p10	;envelope function
ispos	=	p11	;speed of random spatial placement (Hz)
iring	=	p12	;non zero is frequency of ring modultaion

;Add some random frequency deviations
afdev 	randi	ifrq*.01, ifspd, ifsd
aadev	randi	iamp*.1, iaspd, iasd

asnd      	oscil3  iamp+aadev,  ifrq+afdev,  1

;ADD RING MODULATION IF SPECIFIED
if (iring == 0) goto PAN
	aring	oscili	1, iring, 1
	asnd	=	asnd * aring
PAN:
if (ispos >= 0) goto IPAN
	appan 	randi .5, abs(ispos)
	appan	=	(appan+.5)*1.570796325
	goto DONE
IPAN:
appan	=	ispos*1.570796325  ;half of PI (radians of 90o angle)

DONE:
aenv		oscil3	1, 1/p3, ienvf
asnd	=	asnd * aenv

DONENV:
outs	asnd*cos(appan), asnd*sin(appan)
	endin


