;EX4.ORC LE-EVENT GRANULAR SYNTHESIS

;HEADER SECTION
sr 	= 	44100  	;Sampling Rate = 44.1Khz (CD Quality)
kr 	= 	4410   	;Control Rate
ksmps	= 	10     	;Ratio (SR/KR) for internal use
nchnls	=	2	;Number of output channels

gal	init	0
gar	init	0

/*
p4 = ampfac
p5 = file pos
p6 = transp factor
p7 = spatial
p8 = window function
p9 = gen file #
*/
	instr 	1

iamp	=	p4
itransp	=	p6
ispos	=	p7
iwinfn	=	p8
ifile	=	p9
iwet 	=	p10

;FIND SAMPLE VALUE TO READ IN GEN01 TABLE
iesmp	=	nsamp(ifile)
ifpos	= 	p5*iesmp
iend 	=	ifpos 
iamnt	=	p3 * sr * abs(itransp)

;CALCULATE END POSITION (FORWARD OR BACKWARD)
iend	=	(itransp < 0? ifpos - iamnt : ifpos + iamnt)
apoint 	line 	ifpos, p3, iend

;MAKE SOUND FROM GEN01
asnd 	tablei 	apoint, ifile, 0

;SCALE P6 FOR POWER PANNING
ippan	=	ispos*1.570796325  ;half of PI (radians of 90o angle)

;MAKE GRAIN ENVELOPE FROM F2
aenv 	oscil3 	iamp, 1/p3, iwinfn
asnd 	= 	asnd*aenv

al 	=	asnd*sin(ippan)
ar	=	asnd*cos(ippan)

gal	=	gal + al*iwet
gar	=	gar + ar*iwet

	outs	al*(1-iwet), ar*(1-iwet)

	endin


;global reverb instrument
	instr	2
a1	reverb2	gal, 3, .9
a2	reverb2 gar, 3, .9
	outs	(a1+a2*.5)*.75, (a2+a1*.5)*.75
gal	=	0
gar	=	0
	endin

