/*
EX5.ORC: ADDITIVE SYNTHESIS
An orchestra for additive synthesis using a separate i-block for 
each partial.

Coded by M. Vigorito - March, 2001
*/

sr	=	44100
kr	=	4410
ksmps	=	10
nchnls	=	2

	instr 	33

isine	= 	44 	;sine ftable
idur 	= 	p3
iamp 	= 	p4

;p5 is the octave-pitch class of the note
;p6 is the overtone # (0=fundamental)
;now compute the frequency of the partial
ifrq 	= 	cpspch(p5)*(p6+1)

if (ifrq*2 > sr) goto END 	;gaurd against aliasing 

;amplitude envelope parameters
idur1 	= 	p7 	;attack duration in seconds
iamp1 	= 	p8 	;attack amplitude
idur2 	= 	p9 	;decay duration in seconds
iamp2 	= 	p10	;decay amplitude

;P11 is the sustain duration as a fraction of the remaining time of the event
;so we need to compute the sustain duration (idur3) in seconds.
iattk 	= 	idur1+idur2
idur3 	= 	p11*(idur-iattk)
iamp3 	= 	p12 ;sustain amplitude

;Now compute release time as remainder of the event duration.
idur4 	= 	idur-iattk-idur3 

;now generate the amplitude envelope
aamp 	expseg 	.01,idur1,iamp1,idur2,iamp2,idur3,iamp3,idur4,.01

asig 	oscili 	aamp*iamp,ifrq,isine

	outs 	asig,asig

END:
	endin
