;EX6.ORC: A SIMPLE SUBTRACTIVE SYNTHESIS INSTRUMENT USING FILTERED NOISE
;Coded by M. Vigorito - March, 2001

sr 	=	44100
kr	=	4410
ksmps	=	10
nchnls	=	2

	instr	23

idur 	= 	p3	;duration
iamp	=	p4	;amplitude
ifreq	=	p5	;frequency in hertz
iq	=	p6	;Q of the filter

;A half-sine is used for the amplitude envelope -- this is suited for 
;granular-style textures built up from many short, overlapping events

ihsine	=	23 	;ftable for the half-sine

kfreq	=	ifreq	;for now, just use a constant frequency
              		;an envelope could be added for glisses

;Now compute the filter bandwidth... center freq/Q.
kbw 	= 	kfreq/iq

;Here's the amplitude envelope generator:
kenv	oscili	iamp,1/idur,ihsine

anoise	rand	20			;make some noise
afilt 	butbp	anoise,kfreq, kbw	;and filter it

;Apply the amplitude envelope AFTER the filter to avoid clicking at the 
;end of the event due to the delay of the filter.
afilt	=	afilt*kenv

	outs	afilt, afilt

	endin
